VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Device Selector"
   ClientHeight    =   4200
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   6135
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4200
   ScaleWidth      =   6135
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "Save && Exit"
      Height          =   375
      Left            =   3960
      TabIndex        =   6
      Top             =   3720
      Width           =   2055
   End
   Begin VB.ListBox List3 
      Height          =   1815
      ItemData        =   "Form1.frx":030A
      Left            =   120
      List            =   "Form1.frx":030C
      TabIndex        =   4
      Top             =   2280
      Width           =   3735
   End
   Begin VB.ListBox List2 
      Height          =   645
      ItemData        =   "Form1.frx":030E
      Left            =   120
      List            =   "Form1.frx":0310
      TabIndex        =   2
      Top             =   1320
      Width           =   5895
   End
   Begin VB.ListBox List1 
      Height          =   645
      ItemData        =   "Form1.frx":0312
      Left            =   120
      List            =   "Form1.frx":0314
      TabIndex        =   0
      Top             =   360
      Width           =   5895
   End
   Begin VB.Label Label3 
      Caption         =   "Modes :"
      Height          =   195
      Left            =   120
      TabIndex        =   5
      Top             =   2040
      Width           =   570
   End
   Begin VB.Label Label2 
      Caption         =   "Devices :"
      Height          =   195
      Left            =   120
      TabIndex        =   3
      Top             =   1080
      Width           =   675
   End
   Begin VB.Label Label1 
      Caption         =   "Drivers :"
      Height          =   195
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   585
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Declare Function EnumerateDX Lib "Enumerate.dll" (ByVal filename As String) As Integer

Private Sub Command1_Click()
Dim Pth As String

If List1.ListIndex < 0 Then
    MsgBox "Please select a Driver"
    Exit Sub
End If
If List2.ListIndex < 0 Then
    MsgBox "Please select a Device"
    Exit Sub
End If
If List3.ListIndex < 0 Then
    MsgBox "Please select a Mode"
    Exit Sub
End If

Pth = App.Path
If Right(Pth, 1) <> "\" Then Pth = Pth + "\"
Pth = Pth + "RV.ini"

Open Pth For Output As #1
Print #1, "Driver = " + Format(List1.ListIndex)
Print #1, "Device = " + Format(List2.ListIndex)
Print #1, "Mode   = " + Format(List3.ListIndex)
Print #1, "Gamma  = 256"
Close #1

End
End Sub

Private Sub List1_Click()
Dim i As Integer

List2.Clear
List3.Clear
For i = 0 To Drivers(List1.ListIndex).NumDevices - 1
    List2.AddItem Drivers(List1.ListIndex).Devices(i).Desc
Next

End Sub

Private Sub List2_Click()
Dim i As Integer

List3.Clear
For i = 0 To Drivers(List1.ListIndex).Devices(List2.ListIndex).NumModes - 1
    List3.AddItem Drivers(List1.ListIndex).Devices(List2.ListIndex).Modes(i)
Next

End Sub

Private Sub Form_Load()
Dim Pth As String
Dim i As Integer, j As Integer, k As Integer

Pth = App.Path
If Right(Pth, 1) <> "\" Then Pth = Pth + "\"
Pth = Pth + "DriverInfo.txt"

If EnumerateDX(Pth) = 0 Then
    MsgBox "Error enumerating driver info."
    End
End If

Open Pth For Input As #1
Input #1, NumDrivers
For i = 0 To NumDrivers - 1
    Input #1, Drivers(i).Desc
    Input #1, Drivers(i).NumDevices
    For j = 0 To Drivers(i).NumDevices - 1
        Input #1, Drivers(i).Devices(j).Desc
        Input #1, Drivers(i).Devices(j).NumModes
        For k = 0 To Drivers(i).Devices(j).NumModes - 1
            Input #1, Drivers(i).Devices(j).Modes(k)
        Next
    Next
Next
Close #1

List1.Clear
List2.Clear
List3.Clear
For i = 0 To NumDrivers - 1
    List1.AddItem Drivers(i).Desc
Next

End Sub
